"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parse;
exports.test = exports.story = exports.kind = void 0;

var _csf = require("@storybook/csf");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function parse(files) {
  result = {};
  await Promise.all(files.map(async file => Promise.resolve(`${file}`).then(s => _interopRequireWildcard(require(s)))));
  return result;
}

let result = {};
let kindTitle = '';
let storyTitle = '';
let storyParams = null;

const setStoryParameters = params => {
  storyParams = params;
};

const getStoryId = (kindTitle, storyTitle) => {
  return (0, _csf.toId)(kindTitle, (0, _csf.storyNameFromExport)(storyTitle));
};

const kind = (title, kindFn) => {
  kindTitle = title;
  kindFn();
  kindTitle = '';
};

exports.kind = kind;

const story = (title, storyFn) => {
  var _result$storyId;

  storyTitle = title;
  storyParams = null;
  storyFn({
    setStoryParameters
  });
  const storyId = getStoryId(kindTitle, storyTitle);
  result[storyId] = Object.assign({}, storyParams, {
    tests: (_result$storyId = result[storyId]) === null || _result$storyId === void 0 ? void 0 : _result$storyId.tests
  });
  storyTitle = '';
  storyParams = null;
};

exports.story = story;

const test = (title, testFn) => {
  const storyId = getStoryId(kindTitle, storyTitle);

  if (!result[storyId]) {
    result[storyId] = {};
  }

  result[storyId].tests = Object.assign({}, result[storyId].tests, {
    [title]: testFn
  });
};

exports.test = test;