"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = register;

var _pirates = require("pirates");

var _getTsconfig = require("get-tsconfig");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function register(config) {
  (0, _pirates.addHook)(() => '', {
    exts: ['.jpg', '.jpeg', '.png', '.gif', '.eot', '.otf', '.svg', '.ttf', '.woff', '.woff2', '.css', '.less', '.scss', '.styl'],
    ignoreNodeModules: false
  });
  const {
    path: tsConfigPath
  } = (0, _getTsconfig.getTsconfig)(config.tsConfig) || {}; // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-call

  (await Promise.resolve().then(() => _interopRequireWildcard(require('@babel/register')))).default(config.babelOptions({
    babelrc: false,
    rootMode: 'upward-optional',
    ignore: [/node_modules/],
    extensions: ['.js', '.jsx', '.ts', '.tsx'],
    parserOpts: {
      sourceType: 'module',
      plugins: ['jsx', 'typescript']
    },
    presets: ['@babel/preset-typescript', ['@babel/preset-env', {
      targets: {
        node: '10'
      },
      modules: 'commonjs'
    }]],
    plugins: [['@babel/plugin-transform-runtime'], ['babel-plugin-tsconfig-paths', {
      tsconfig: tsConfigPath
    }]]
  }));
  (await Promise.resolve().then(() => _interopRequireWildcard(require('ts-node')))).register({
    project: tsConfigPath,
    transpileOnly: true
  });
}